about summary refs log tree commit homepage
diff options
context:
space:
mode:
authorAlfred Perlstein <alfred@freebsd.org>2014-12-07 02:47:23 -0800
committerEric Wong <normalperson@yhbt.net>2014-12-09 22:03:15 +0000
commit83c9433e679635f8fbf8961081ea3581c93ca778 (patch)
tree4663fdcd4734005a7cfcd54653f748316f20b298
parentc18b86734113ee2aeb0e140c922c8fbd4accc860 (diff)
downloadgit-svn-83c9433e6796.tar.gz
This change allows git-svn to support setting subversion properties.

It is useful for manually setting properties when committing to a
subversion repo that *requires* properties to be set without requiring
moving your changeset to separate subversion checkout in order to
set props.

This change is initially from David Fraser, appearing at:

  http://mid.gmane.org/1927112650.1281253084529659.JavaMail.root@klofta.sjsoft.com>

They are now forward-ported to most recent git along with fixes to
deal with files in subdirectories.

Style and functional changes from Eric Wong have been taken
in their entirety from:

  http://mid.gmane.org/20141201094911.GA13931@dcvr.yhbt.net

There is a nit to point out: the code does not support
adding props unless there are also content changes to the files as
well.  This is demonstrated in the testcase.

[ew - simplify Git.pm usage for check-attr
    - improve shell portability for tests
    - minor phrasing changes in commit message]

Signed-off-by: David Fraser <davidf@sjsoft.com>
Signed-off-by: Alfred Perlstein <alfred@freebsd.org>
Signed-off-by: Eric Wong <normalperson@yhbt.net>
-rwxr-xr-xgit-svn.perl49
-rw-r--r--perl/Git/SVN/Editor.pm38
-rwxr-xr-xt/t9148-git-svn-propset.sh95
3 files changed, 181 insertions, 1 deletions
diff --git a/git-svn.perl b/git-svn.perl
index b6e2186cef..60f8814cc5 100755
--- a/git-svn.perl
+++ b/git-svn.perl
@@ -115,7 +115,7 @@ my ($_stdin, $_help, $_edit,
         $_before, $_after,
         $_merge, $_strategy, $_preserve_merges, $_dry_run, $_parents, $_local,
         $_prefix, $_no_checkout, $_url, $_verbose,
-        $_commit_url, $_tag, $_merge_info, $_interactive);
+        $_commit_url, $_tag, $_merge_info, $_interactive, $_set_svn_props);
 
 # This is a refactoring artifact so Git::SVN can get at this git-svn switch.
 sub opt_prefix { return $_prefix || '' }
@@ -193,6 +193,7 @@ my %cmd = (
                           'dry-run|n' => \$_dry_run,
                           'fetch-all|all' => \$_fetch_all,
                           'commit-url=s' => \$_commit_url,
+                          'set-svn-props=s' => \$_set_svn_props,
                           'revision|r=i' => \$_revision,
                           'no-rebase' => \$_no_rebase,
                           'mergeinfo=s' => \$_merge_info,
@@ -228,6 +229,9 @@ my %cmd = (
         'propget' => [ \&cmd_propget,
                        'Print the value of a property on a file or directory',
                        { 'revision|r=i' => \$_revision } ],
+        'propset' => [ \&cmd_propset,
+                       'Set the value of a property on a file or directory - will be set on commit',
+                       {} ],
         'proplist' => [ \&cmd_proplist,
                        'List all properties of a file or directory',
                        { 'revision|r=i' => \$_revision } ],
@@ -1376,6 +1380,49 @@ sub cmd_propget {
         print $props->{$prop} . "\n";
 }
 
+# cmd_propset (PROPNAME, PROPVAL, PATH)
+# ------------------------
+# Adjust the SVN property PROPNAME to PROPVAL for PATH.
+sub cmd_propset {
+        my ($propname, $propval, $path) = @_;
+        $path = '.' if not defined $path;
+        $path = $cmd_dir_prefix . $path;
+        usage(1) if not defined $propname;
+        usage(1) if not defined $propval;
+        my $file = basename($path);
+        my $dn = dirname($path);
+        my $cur_props = Git::SVN::Editor::check_attr( "svn-properties", $path );
+        my @new_props;
+        if (!$cur_props || $cur_props eq "unset" || $cur_props eq "" || $cur_props eq "set") {
+                push @new_props, "$propname=$propval";
+        } else {
+                # TODO: handle combining properties better
+                my @props = split(/;/, $cur_props);
+                my $replaced_prop;
+                foreach my $prop (@props) {
+                        # Parse 'name=value' syntax and set the property.
+                        if ($prop =~ /([^=]+)=(.*)/) {
+                                my ($n,$v) = ($1,$2);
+                                if ($n eq $propname) {
+                                        $v = $propval;
+                                        $replaced_prop = 1;
+                                }
+                                push @new_props, "$n=$v";
+                        }
+                }
+                if (!$replaced_prop) {
+                        push @new_props, "$propname=$propval";
+                }
+        }
+        my $attrfile = "$dn/.gitattributes";
+        open my $attrfh, '>>', $attrfile or die "Can't open $attrfile: $!\n";
+        # TODO: don't simply append here if $file already has svn-properties
+        my $new_props = join(';', @new_props);
+        print $attrfh "$file svn-properties=$new_props\n" or
+                die "write to $attrfile: $!\n";
+        close $attrfh or die "close $attrfile: $!\n";
+}
+
 # cmd_proplist (PATH)
 # -------------------
 # Print the list of SVN properties for PATH.
diff --git a/perl/Git/SVN/Editor.pm b/perl/Git/SVN/Editor.pm
index 34e8af966c..4088f13e72 100644
--- a/perl/Git/SVN/Editor.pm
+++ b/perl/Git/SVN/Editor.pm
@@ -288,6 +288,40 @@ sub apply_autoprops {
         }
 }
 
+sub check_attr {
+        my ($attr,$path) = @_;
+        my $val = command_oneline("check-attr", $attr, "--", $path);
+        if ($val) { $val =~ s/^[^:]*:\s*[^:]*:\s*(.*)\s*$/$1/; }
+        return $val;
+}
+
+sub apply_manualprops {
+        my ($self, $file, $fbat) = @_;
+        my $pending_properties = check_attr( "svn-properties", $file );
+        if ($pending_properties eq "") { return; }
+        # Parse the list of properties to set.
+        my @props = split(/;/, $pending_properties);
+        # TODO: get existing properties to compare to
+        # - this fails for add so currently not done
+        # my $existing_props = ::get_svnprops($file);
+        my $existing_props = {};
+        # TODO: caching svn properties or storing them in .gitattributes
+        # would make that faster
+        foreach my $prop (@props) {
+                # Parse 'name=value' syntax and set the property.
+                if ($prop =~ /([^=]+)=(.*)/) {
+                        my ($n,$v) = ($1,$2);
+                        for ($n, $v) {
+                                s/^\s+//; s/\s+$//;
+                        }
+                        my $existing = $existing_props->{$n};
+                        if (!defined($existing) || $existing ne $v) {
+                            $self->change_file_prop($fbat, $n, $v);
+                        }
+                }
+        }
+}
+
 sub A {
         my ($self, $m, $deletions) = @_;
         my ($dir, $file) = split_path($m->{file_b});
@@ -296,6 +330,7 @@ sub A {
                                         undef, -1);
         print "\tA\t$m->{file_b}\n" unless $::_q;
         $self->apply_autoprops($file, $fbat);
+        $self->apply_manualprops($m->{file_b}, $fbat);
         $self->chg_file($fbat, $m);
         $self->close_file($fbat,undef,$self->{pool});
 }
@@ -311,6 +346,7 @@ sub C {
         my $fbat = $self->add_file($self->repo_path($m->{file_b}), $pbat,
                                 $upa, $self->{r});
         print "\tC\t$m->{file_a} => $m->{file_b}\n" unless $::_q;
+        $self->apply_manualprops($m->{file_b}, $fbat);
         $self->chg_file($fbat, $m);
         $self->close_file($fbat,undef,$self->{pool});
 }
@@ -333,6 +369,7 @@ sub R {
                                 $upa, $self->{r});
         print "\tR\t$m->{file_a} => $m->{file_b}\n" unless $::_q;
         $self->apply_autoprops($file, $fbat);
+        $self->apply_manualprops($m->{file_b}, $fbat);
         $self->chg_file($fbat, $m);
         $self->close_file($fbat,undef,$self->{pool});
 
@@ -348,6 +385,7 @@ sub M {
         my $fbat = $self->open_file($self->repo_path($m->{file_b}),
                                 $pbat,$self->{r},$self->{pool});
         print "\t$m->{chg}\t$m->{file_b}\n" unless $::_q;
+        $self->apply_manualprops($m->{file_b}, $fbat);
         $self->chg_file($fbat, $m);
         $self->close_file($fbat,undef,$self->{pool});
 }
diff --git a/t/t9148-git-svn-propset.sh b/t/t9148-git-svn-propset.sh
new file mode 100755
index 0000000000..102639090c
--- /dev/null
+++ b/t/t9148-git-svn-propset.sh
@@ -0,0 +1,95 @@
+#!/bin/sh
+#
+# Copyright (c) 2014 Alfred Perlstein
+#
+
+test_description='git svn propset tests'
+
+. ./lib-git-svn.sh
+
+foo_subdir2="subdir/subdir2/foo_subdir2"
+
+set -e
+mkdir import &&
+(set -e ; cd import
+        mkdir subdir
+        mkdir subdir/subdir2
+        touch foo                 # for 'add props top level'
+        touch subdir/foo_subdir # for 'add props relative'
+        touch "$foo_subdir2"        # for 'add props subdir'
+        svn_cmd import -m 'import for git svn' . "$svnrepo" >/dev/null
+)
+rm -rf import
+
+test_expect_success 'initialize git svn' '
+        git svn init "$svnrepo"
+        '
+
+test_expect_success 'fetch revisions from svn' '
+        git svn fetch
+        '
+
+set_props () {
+        subdir="$1"
+        file="$2"
+        shift;shift;
+        (cd "$subdir" &&
+                while [ $# -gt 0 ] ; do
+                        git svn propset "$1" "$2" "$file" || exit 1
+                        shift;shift;
+                done &&
+                echo hello >> "$file" &&
+                git commit -m "testing propset" "$file")
+}
+
+confirm_props () {
+        subdir="$1"
+        file="$2"
+        shift;shift;
+        (set -e ; cd "svn_project/$subdir" &&
+                while [ $# -gt 0 ] ; do
+                        test "$(svn_cmd propget "$1" "$file")" = "$2" || exit 1
+                        shift;shift;
+                done)
+}
+
+
+#The current implementation has a restriction:
+#svn propset will be taken as a delta for svn dcommit only
+#if the file content is also modified
+test_expect_success 'add props top level' '
+        set_props "." "foo" "svn:keywords" "FreeBSD=%H" &&
+        git svn dcommit &&
+        svn_cmd co "$svnrepo" svn_project &&
+        confirm_props "." "foo" "svn:keywords" "FreeBSD=%H" &&
+        rm -rf svn_project
+        '
+
+test_expect_success 'add multiple props' '
+        set_props "." "foo" \
+                "svn:keywords" "FreeBSD=%H" fbsd:nokeywords yes &&
+        git svn dcommit &&
+        svn_cmd co "$svnrepo" svn_project &&
+        confirm_props "." "foo" \
+                "svn:keywords" "FreeBSD=%H" fbsd:nokeywords yes &&
+        rm -rf svn_project
+        '
+
+test_expect_success 'add props subdir' '
+        set_props "." "$foo_subdir2" svn:keywords "FreeBSD=%H" &&
+        git svn dcommit &&
+        svn_cmd co "$svnrepo" svn_project &&
+        confirm_props "." "$foo_subdir2" "svn:keywords" "FreeBSD=%H" &&
+        rm -rf svn_project
+        '
+
+test_expect_success 'add props relative' '
+        set_props "subdir/subdir2" "../foo_subdir" \
+                svn:keywords "FreeBSD=%H" &&
+        git svn dcommit &&
+        svn_cmd co "$svnrepo" svn_project &&
+        confirm_props "subdir/subdir2" "../foo_subdir" \
+                svn:keywords "FreeBSD=%H" &&
+        rm -rf svn_project
+        '
+test_done